        PAGE 72,120
        TITLE Asmdemo4  -  fylder skrmen op med tegn direkte i buffer
;-----------------------------------------------------------------------------
;       Bjrk Busch   2/5-1990          Eksempel p EXE program.
;-----------------------------------------------------------------------------

Cseg    Segment Para Public 'CODE'

        Assume Cs:Cseg,Ds:Dseg,Es:nothing,Ss:Sseg
;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Main    Proc    Near
        Mov     Ax,Seg Dseg             ; etabler
        Mov     Ds,Ax                   ;     datasegment

        Call    Clear

        Mov     Es,SkrmSeg              ; Es:0000 -> skrmbuffer

        XOR     Di,Di                   ; Es:Di -> start p skrmbuffer
        Mov     Si,Offset Txt1          ; Ds:Si -> tekst som skal udskrives 
        Mov     Bx,Offset Txt1end       ; Bx -> slutadresse (offset)
        Mov     Ah,Attrib               ; Ah := attribute
        Call    Skriv

Loop:   Call    ReadKbd                 ; indls tegn
        Cmp     Al,27                   ; test for ESC
        Je      EndLoop                 ;   og stop hvis det er
        Mov     Ah,Attrib               ; opst attribut
        Call    ScrFyld
        Jmp     Loop                    ; igen
EndLoop:


        Call    Clear

        XOR     Di,Di                   ; Es:Di -> start p skrmbuffer
        Mov     Si,Offset Txt2          ; Ds:Si -> tekst som skal udskrives 
        Mov     Bx,Offset Txt2end       ; Bx -> slutadresse (offset)
        Mov     Ah,Attrib               ; Ah := attribute
        Call    Skriv

        Call    Curs20

        Mov     Al,0                    ; Returkode = 0
        Mov     Ah,TermPro              ; opst funktion for
        Int     DosServ                 ; terminate og udfr

Main    EndP
;-----------------------------------------------------------------------------
;       Slut p Hovedrutine
;-----------------------------------------------------------------------------


Clear   Proc    Near
;------------------------------------------------------------------------
; Proceduren anvendes til blanke skrmen ved brug af scroll funktion
; Rutinen anvender flgende registre som arbejdsregistre
;       Ax,Bh,Cx,Dx     som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Ax                      ; save
        Push    Bx                      ;    arbejds-
        Push    Cx                      ;       registre
        Push    Dx
        Mov     Ah,06h                  ; scroll up
        Mov     Al,0                    ; 0 = blank omrde
        Mov     Ch,0                    ; linie 0
        Mov     Cl,0                    ; kolonne 0
        Mov     Dh,24                   ; linie 24
        Mov     Dl,79                   ; kolonne 79
        Mov     Bh,07h                  ; normal attribute
        Int     ScrInt                  ; skrm interupt
        Pop     Dx                      ; restore
        Pop     Cx                      ;    arbejds-
        Pop     Bx                      ;       registre
        Pop     Ax
        Ret                             ; Returner
Clear   EndP

Curs20 Proc    Near
;------------------------------------------------------------------------
; Proceduren placerer cursoren i starten af linie 20
;       det forudsttes at man er i page 0
; Rutinen anvender flgende registre som arbejdsregistre
;       Ax,Bh,Dx                som gemmes og restores ved afslutning
;------------------------------------------------------------------------
        Push    Ax                      ; save
        Push    Bx                      ;    arbejds-
        Push    Dx                      ;       registre
        Mov     Ah,2h                   ; set cursor funktion
        Mov     Dh,20                   ; linie 20
        Mov     Dl,0                    ; kolonne 0
        Mov     Bh,0                    ; page 0
        Int     ScrInt                  ; skrm interupt
        Pop     Dx                      ; restore
        Pop     Bx                      ;    arbejds-
        Pop     Ax                      ;       registre
        Ret                             ; Returner
Curs20  EndP

ReadKbd Proc    Near
;------------------------------------------------------------------------
; Proceduren indlser et tegn fra keyboardbufferen
; Flgende Returneres
;       Ah      scankode
;       Al      ascii-kode
;------------------------------------------------------------------------
        Mov     Ah,00h                  ; read key funktion
        Int     KbdInt                  ; keyboard interupt
        Ret                             ; Returner
ReadKbd EndP

Skriv   Proc    Near
;------------------------------------------------------------------------
; Proceduren anvendes til at udskrive en tekst direkte i buffer
; Flgende parametre overgives
;       Ds:Si   skal indeholde startadresse p tekst
;       Ds:Bx   skal indeholde adresse p frste byte efter tekst
;       Es:Di   start skrmadresse for frste tegn
;       Al      skal indeholde attribute
; Flgende Returneres
;       Es:Di   indeholder ved Retur nste skrmadresse
;       Ds:Si   stopadresse (samme som DS:Bx)
; Rutinen anvender flgende registre som arbejdsregistre
;       Ah              som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Ax                      ; save arbejdsregister
while:  Cmp     Si,Bx                   ; while 
        Je      endwhile                ;   Si <> Bx  (flere tegn i tekst)
        Mov     Al,Ds:[Si]              ; Al := ascii-tegn
        Mov     Es:[Di],Ax              ; flyt tegn+attribute til skrmbuffer
        Inc     Di                      ; tl skrmadresse
        Inc     Di                      ;   op til nste tegn
        Inc     Si                      ; Ds:Cx -> nste ascci tegn
        Jmp     while
endwhile:
        Pop     Ax                      ; restore arbejdsregister
        Ret                             ; Returner
Skriv   EndP

ScrFyld  Proc    Near
;------------------------------------------------------------------------
; Proceduren fylder skrmen med tegnetX'er direkte i bufferen
; Flgende parametre overgives
;       Es      skrm-segment-adresse
;       Ah      skal indeholde fyldtegn
;       Al      skal indeholde attribute
; Rutinen anvender flgende registre som arbejdsregistre
;       Di              som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Di                      ; gem Di
        Xor     Di,Di                   ; nulstil -- ES:Di -> skrmbuffer
while2: Cmp     Di,4000                 ; while 
        Je      ewhile2                 ;   Di <> 4000  (slut p buffer)
        Mov     Es:[Di],Ax              ; flyt tegn+attribute til skrmbuffer
        Inc     Di                      ; tl skrmadresse
        Inc     Di                      ;   op til nste tegn
        Jmp     while2
ewhile2:
        Pop     Di                      ; restore Di
        Ret                             ; Returner
ScrFyld EndP
;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p code-segment


Dseg    Segment Para Public 'DATA'
;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ Equ     21H                     ; dos service interupt
ScrInt  Equ     10H                     ; video interupt
KbdInt  Equ     16H                     ; keyboard interupt
WrtStr  Equ     9H                      ; dos write streng DS:DX p skrm
TermPro Equ     4CH                     ; dos terminate
CR      Equ     13
NL      Equ     10
ESC     Equ     27

SkrmSeg Dw      0B800H                  ; B000h for monokrom (IBM)
                                        ; B800h for color (IBM)
                                        ; F000h for siemens PCD
attrib  Db      7H                      ;normal skrift

txt1    Db      'Tast p et tegn og se skrmen blive fyldt '
        Db      'op - Afbryd med ESC'
txt1end Db      ?

txt2    Db      'Det var hurtig skrmbehandling ikke ????'
txt2end Db      ?
;-----------------------------------------------------------------------------
Dseg    EndS                            ; slut p data-segment


Sseg    Segment Para Stack 'STACK'
;-----------------------------------------------------------------------------
;       Stack
;-----------------------------------------------------------------------------
        dw      128 dup(?)              ; der er sat 128 ord af til stack
;-----------------------------------------------------------------------------
Sseg    EndS                            ; slut p stack-segment

        End     Main                    ; Slut og opst startadresse
