   PAGE 72,96
   TITLE AsmPas:  Eksempel p underrutiner i assembler til brug i pascal
;
;  Programmr:  Bjrk Boye Busch     7/12-1989
;
;  Eksempler p hvorledes man fremstiller underprogrammer til pascal
;  i assembler. Rutierne viser samtidig hvorledes pascal arbejder.
;
;  Rutinerne oversttes, linkes og konverteres til en BIN-fil med EXE2BIN
;
;
;Pascal definition        
;
;Procedure AsmPas;                      External 'ASMPAS.BIN';
;
;Bemrk:
;Der er sat plads af til funktiosvariablen p stakken. (nederst i parameter-
;stakken)
;funktioner af typen BYTE, CHAR, INTEGER og BOOLEAN placerer resultatet
;i Ax registeret. En BOOLEAN skal stte Z-flaget, hvilket kan gres med
;instruktionen " OR Ax,Ax " lige fr returnering. 
;Der er dog sat plads af p stakken svarende til den anvendte definition,
;og stakken skal derfor justeres med 1 for BYTE, CHAR og BOOLEAN og med
;2 for INTEGER.
;Funktioner af pointertypen afleverer resultatet i Dx:Ax, hvor Dx indeholder
;segmentadressen og Ax ofsetadressen. Husk at tage af stakken.
;Funktioner af typen REAL afleverer resultatet p toppen af stakken. Dette
;gres lettes ved, at lade variablen ligge og fjerne evt. parametre ved
;returneringen.
;Funktioner af typen strenge skal afleveres verst p stakken i normaliseret
;form, sledes at de kun optager den plads, indholdet+lngdebyten optager.
;Strenge kan sledes vre besvrlige, da de kan krve en rokade.
;


Cseg    Segment PARA PUBLIC 'CODE'
        Assume Cs:Cseg,Ds:Cseg,Es:Cseg

        ORG     100H

MAIN    Proc    Near
;----------------------------------------------------------------------------
; dette er hovedrutinen som indeholder en jump-tabel
;----------------------------------------------------------------------------

ep000:  jmp     DosRetur                ;External  DOSKALD[0] 
ep003:  jmp     GetDate                 ;External  DOSKALD[3] 
ep006:  jmp     GetTime                 ;External  DOSKALD[6] 
ep009:  jmp     Equipmen                ;External  DOSKALD[9]
ep012:  jmp     KbdFlag1                ;External  DOSKALD[12]
ep015:  jmp     KbdFlag2                ;External  DOSKALD[15]
ep018:  jmp     StakPtr                 ;External  DOSKALD[18]
ep021:  jmp     Boolean                 ;External  DOSKALD[21]
ep024:  jmp     Rtal                    ;External  DOSKALD[24]
ep027:  jmp     Streng                  ;External  DOSKALD[27]
ep030:  jmp     kald0                   ;External  DOSKALD[30]
ep033:  jmp     kald0                   ;External  DOSKALD[33]

MAIN    Endp


kald0   Proc    Near
        ret
Kald0   Endp


DosRetur Proc Near
;denne rutine anvendes, hvis der forsges med opstart direkte fra DOS (EXE-fil)

DosInt  equ     21h                     ; DOS service interupt
WriteTx equ     9h                      ; DOS funktion - write textstr. p skrm
Term    equ     4Ch                     ; DOS funktion - terminer program
BEL     equ     7                       ; skrmdyt
CR      equ     13                      ; carrige return
LF      equ     10                      ; line feed

        mov     Ax,Cs                   ; opst     (kun ndv. for EXE-fil)
        mov     Ds,Ax                   ;    datasegment
        CLI                             ; LUK INT
        mov     Ss,Ax                   ;    staksegment
        mov     Sp,offset stakend       ;    og stakpointer
        STI                             ; BEN igen

        mov     Ah,WriteTx              ; funk = skriv til $ tegn
        mov     Dx,offset fejltxt       ; Ds:Dx -> fejltxt
        int     DosInt                  ; udskriv fejltxt
        
        mov     Ah,Term                 ; terminer
        int     DosInt                  ;     Program

fejltxt db      'Dette er ikke et selvstndig program, '
        db      'men underrutiner til PASCAL',BEL,CR,LF,'$'

;-----------------------------------------------------------------------------
;       Stak
;-----------------------------------------------------------------------------
        dw      25  dup(0)               ; der er sat 26 ord
stakend dw      0                       ;    af til stak
;-----------------------------------------------------------------------------

DosRetur EndP


StakPtr Proc    Near
;Function StakPtr: integer;
;returnerer stakpointer for kontrol af stakjustering
        mov     Ax,Sp
        ret     02              ;returner og juster stak
StakPtr EndP        


GetDate Proc    Near
;procedure getdate henter datoen fra systemet
;Pascal definition
;Procedure GetDate(var aa:integer;var mm,dd,ugedg:byte);
;
        push    Bp              ;gem basispointer
        mov     Bp,Sp           ;Bp -> staktop -- sidste parameter er 4 hjere
        push    Cx              ;gem arbejdsregistre
        push    Dx
        push    Es
        push    Si

        mov     Ah,2Ah          ;funktion GET DATE
        INT     21h             ;Dos service funktion
        
        mov     Si,SS:[Bp+4]    ;Si := offset adr. p sidste parm
        mov     Es,SS:[Bp+6]    ;Es := segment adr. p sidste parm
        mov     ES:[Si],Al      ;returner ugedag

        mov     Si,SS:[Bp+8]    ;Si := offset  adr. p 2. sidste parm
        mov     Es,SS:[Bp+10]   ;Es := segment adr. p 2. sidste parm
        mov     ES:[Si],Dl      ;returner dag

        mov     Si,SS:[Bp+12]   ;Si := offset  adr. p 3. sidste parm
        mov     Es,SS:[Bp+14]   ;Es := segment adr. p 3. sidste parm
        mov     ES:[Si],Dh      ;returner mned

        mov     Si,SS:[Bp+16]   ;Si := offset  adr. p 4. sidste parm
        mov     Es,SS:[Bp+18]   ;Es := segment adr. p 4. sidste parm
        mov     ES:[Si],Cx      ;returner rstal

        pop     Si              ;restore arbejdsregistre
        pop     Es
        pop     Dx
        pop     Cx
        pop     Bp              ; restore basispointer
        
        ret     16              ;returner og juster stak (parm 4*(2 ord))

GetDate EndP


GetTime Proc    Near
;procedure gettime henter klokken fra systemet
;Pascal definition
;Procedure GetTime(var time,minut,sek,s100:byte);
;
        push    Bp              ;gem basispointer
        mov     Bp,Sp           ;Bp -> staktop -- frste parameter er 4 hjere
        push    Cx              ;gem arbejdsregistre
        push    Dx
        push    Es
        push    Si

        mov     Ah,2Ch          ;funktion GET TIME
        INT     21h             ;Dos service funktion

        mov     Si,SS:[Bp+4]    ;Si := offset adr. p sidste parm
        mov     Es,SS:[Bp+6]    ;Es := segment adr. p sidste parm
        mov     ES:[Si],Dl      ;returner S100

        mov     Si,SS:[Bp+8]    ;Si := offset  adr. p 2. sidste parm
        mov     Es,SS:[Bp+10]   ;Es := segment adr. p 2. sidste parm
        mov     ES:[Si],Dh      ;returner SEK

        mov     Si,SS:[Bp+12]   ;Si := offset  adr. p 3. sidste parm
        mov     Es,SS:[Bp+14]   ;Es := segment adr. p 3. sidste parm
        mov     ES:[Si],Cl      ;returner MINUT

        mov     Si,SS:[Bp+16]   ;Si := offset  adr. p 4. sidste parm
        mov     Es,SS:[Bp+18]   ;Es := segment adr. p 4. sidste parm
        mov     ES:[Si],Ch      ;returner TIME

        pop     Si              ;restore arbejdsregistre
        pop     Es
        pop     Dx
        pop     Cx
        pop     Bp              ; restore basispointer
        
        ret     16              ;returner og juster stak (parm 4*(2 ord))

GetTime Endp


Equipmen Proc   Near
;function equipmen henter "equipment"flag i offset 10h-11h
;Pascal definition
;Function Equipment:byte;

        push    Es
        mov     Ax,0
        mov     Es,Ax
        mov     Ax,ES:[410h]    ;returner flag i Ax register
        pop     Es
        ret     02              ;returner og juster stak

Equipmen Endp


KbdFlag1 Proc   Near
;function kbdflag1 henter tastaturflag i offset 17h
;Pascal definition
;Function KbdFlag1:byte;

        push    Es
        xor     Ax,Ax           ;Ax := 0
        mov     Es,Ax           ;page nul
        mov     Al,ES:[417h]    ;returner flag i Al register
        pop     Es
        ret     01              ;returner og juster stak

KbdFlag1 Endp


KbdFlag2 Proc   Near
;function kbdflag2 henter tastaturflag i offset 18h
;Pascal definition
;Function KbdFlag2:byte;

        push    Es
        xor     Ax,Ax           ;Ax := 0
        mov     Es,Ax           ;page nul
        mov     Al,ES:[418h]    ;returner flag i Al register
        pop     Es
        ret     01              ;returner og juster stak

KbdFlag2 Endp


;eksempler p andre kald fra pascal

Boolean Proc    Near
        mov     Ax,1
        or      Ax,Ax           ; st flag    (TRUE)
        ret     01              ; returner og juster stak
Boolean Endp


Rtal    Proc    Near
;Pascal definition
;Function Rtal: real;
;
        push    Bp              ;gem basispointer
        mov     Bp,Sp           ;Bp -> staktop -- sidste parameter er 4 hjere

        xor     Ax,Ax           ;Ax := 0
        mov     Al,1            ;
        mov     SS:[Bp+4],Al    ;st mantisse
        mov     SS:[Bp+5],Al    ;
        mov     SS:[Bp+6],Al    ;
        mov     SS:[Bp+7],Al    ;
        mov     SS:[Bp+8],Al    ;

        mov     SS:[Bp+9],Al    ;st eksponent

        pop     Bp              ; restore basispointer
        
        ret                     ;returner og juster stak

Rtal    Endp


Streng  Proc    Near
;Pascal definition
;Function Streng: string(.5.);
;
        push    Bp              ;gem basispointer
        mov     Bp,Sp           ;Bp -> staktop -- sidste parameter er 4 hjere

        mov     Al,5            ;st strenglngde
        mov     SS:[Bp+4],Al    ;   nrmest staktop
        mov     Al,48
        mov     SS:[Bp+5],Al    ;1. tegn
        inc     Al
        mov     SS:[Bp+6],Al    ;2. tegn
        inc     Al
        mov     SS:[Bp+7],Al    ;3. tegn
        inc     Al
        mov     SS:[Bp+8],Al    ;4. tegn
        inc     Al
        mov     SS:[Bp+9],Al    ;5. tegn

        pop     Bp              ; restore basispointer
        
        ret                     ;returner og juster stak

Streng  Endp


cseg    ends
        end     MAIN
        