        PAGE 72,120
        TITLE AsmPSP  -  brug af strukturer og access af PSP
;-----------------------------------------------------------------------------
;       Bjrk Busch  13/5-1990          Eksempel p EXE program.
;-----------------------------------------------------------------------------

PSPseg  Segment Para COMMON
;-----------------------------------------------------------------------------
;       PSP-segment     skal ligge frst i program
;-----------------------------------------------------------------------------
PSPtype Struc
;-----------------------------------------------------------------------------
;       Struktur-definition (layout) for Program Segment Prefix (PSP).
;       En struktur "fylder" ikke i lageret  -  svarer til TYPE i PASCAL.
;       Man skal normalt IKKE ndre i PSP'et da DOS'en bruger dette dataomrde.
;       Nr program starter peger Ds og Es p PSP'en, ellers kan man
;       f fat i adressen (segment) med DOS-interupt 21, funktion 62h.
;       For COM filer skal denne struktur ligge i starten af kodesegmentet,
;       da DOS-en her forventer at 100h byte er reserveret til PSP'et.
;-----------------------------------------------------------------------------
Int20instr  Dw  ?         ; Int 20 - instruktion
EoAllBlk    Dw  ?         ; Slutadresse for allokeringsblok
            Db  ?         ; Reserveret
CallAdr     Db  ?         ; Long Call - Offset add Function dispatcher
FunkDispAdr DD  ?         ; Function dispatcher adresse ( offset, Segment)
TermAdr     DD  ?         ; Terminerings adresse ( Ip, Cs )
CtrlCExit   DD  ?         ; Control-C exit adresse ( Ip, Cs )  KAN evt. NDRES
HardExit    DD  ?         ; Hardware fejl - exit adresse ( Ip, Cs )
            Db  22 Dup(?) ; Reserveret til MS-DOS
EnvSeg      Dw  ?         ; Segmentadr. p enviromentdata COMSPEC m.m.
                          ; informationer adskilles af binr-0 og referencer
                          ; sluttes med 2 stk. binr-0.
            Db  34 Dup(?) ; Reserveret til MS-DOS
Int21instr  Dw  ?         ; Int 21 - instruktion
RetFinstr   Db  ?         ; RetF   - instruktion
            Db  9 Dup(?)  ; Reserveret
ParmBlk1    DD  ?         ; 
FCB1        Db  12 Dup(?) ; Frste parameter (ved redir. input filnavn)
ParmBlk2    DD  ?         ; 
FCB2        Db  12 Dup(?) ; Anden parameter (ved redir. output filnavn)
ParmBlk3    DD  ?         ; 
CmdLinLen   Db  ?         ; Lngde af komandolinie (opstarts-parametre)
CmdLin      Db  127 Dup(?); Komandolinie (opstarts-parametre)
                          ;   her findes komandolinie med undtagelse af
                          ;   navn p det opstartede program.
;-----------------------------------------------------------------------------
PSPtype EndS                            ; slut p struktur
;-----------------------------------------------------------------------------
;       Egentlig segnent definition
;-----------------------------------------------------------------------------
PSP     PSPtype <>                      ; definer PSP  (ingen initiering)

PSPseg  EndS                            ; slut p segment


Cseg    Segment Para Public 'CODE'

        Assume Cs:Cseg,Ds:Dseg,Es:nothing,Ss:Sseg
;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Main    Proc    Near

        Mov     Ax,Seg Dseg             ; etabler
        Mov     Ds,Ax                   ;     datasegment
        
        Mov     Dx,Offset ClrScr        ; DS:DX -> ClrScr (ansi-esc.sekv.)
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Push    Ds                      ; gem adressse p Dseg  (datasegment)

        Push    Es                      ; Gem adr. p PSP  (sttes af DOS -
                                        ;                   ved opstart.)
        Mov     Es,SkrmSeg              ; opst Es som pegepind til skrmbuf.
        XOR     Di,Di                   ; Es:Di -> start p skrmbuffer

        Mov     Ah,Attrib               ; Ah := attribute

        Pop     Ds                      ; Ds -> nu p PSP
        Assume  Ds:PSPseg               ; fortl overstter af nu skal
                                        ;   PSP-struktur anvendes ved offset-
                                        ;   beregninger baseret p Ds

        Xor     Si,Si                   ; -> udskr. position i CmdLin  (0)
        Xor     Bx,Bx                   ; Bx :=
        Mov     Bl,PSP.CmdLinLen        ;      CmdLinLen
        
While:  Cmp     Si,Bx                   ; while 
        Je      EndWhile                ;   Si <> Bx (flere tegn i CmdLin)
        Mov     Al,PSP.CmdLin[Si]       ; Al := tegn i komandolinie
        Mov     Es:[Di],Ax              ; flyt tegn+attribute til skrmbuffer
        Inc     Di                      ; tl skrmadresse
        Inc     Di                      ;   op til nste tegn
        Inc     Si                      ; Ds:Si -> nste ascci tegn
        Jmp     While
EndWhile:

        Pop     Ds                      ; Ds -> Dseg igen
        Assume  Ds:Dseg                 ; fortl overstter det

        Mov     Dx,Offset Flytcur       ; DS:DX -> flytcur
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Al,0                    ; returkode = 0
        Mov     Ah,TermPro              ; opst funktion for
        Int     DosServ                 ; terminate og udfr
Main    EndP
;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p code-segment


Dseg    Segment Para Public 'DATA'
;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ Equ     21H                     ; dos service interupt
WrtStr  Equ     9H                      ; dos write streng DS:DX p skrm
TermPro Equ     4CH                     ; dos terminate
CR      Equ     13
NL      Equ     10

ClrScr  Db      27,'[2J$'               ; ansi-escape sekv. for blank skrm
SkrmSeg Dw      0B800H                  ; B000h for monokrom (IBM)
                                        ; B800h for color (IBM)
                                        ; F000h for siemens PCD
Attrib  Db      7H                      ;normal skrift

Flytcur Db      27,'[20B$'
;-----------------------------------------------------------------------------
Dseg    EndS                            ; slut p data-segment


Sseg    Segment Para Stack 'STACK'
;-----------------------------------------------------------------------------
;       Stack
;-----------------------------------------------------------------------------
        dw      128 dup(129)            ; der er sat 128 ord af til stack
;-----------------------------------------------------------------------------
Sseg    EndS                            ; slut p stack-segment


        End     Main                    ; Slut og opst startadresse
