        PAGE 72,120
        TITLE AsmRes   Resident Keyboard-driver (ombytter bogstaver)
;-----------------------------------------------------------------------------
;       Bjrk Busch   2/5-1990          Eksempel p RESISTENT  COM-program
;
;       NB!  Der m IKKE reffereres til data efter selve driver-proceduren
;            nr driveren er instaleret, da disse data frigives til sidst
;            i instaleringen.
;-----------------------------------------------------------------------------

Cseg    segment
        assume Cs:cseg,Ds:cseg,Es:cseg,Ss:cseg

;-----------------------------------------------------------------------------
;       Equ definitioner
;-----------------------------------------------------------------------------

BiosInt Equ     16h                     ; Bios Keyboard interrupt
KbdInt  Equ     62h                     ; Flyttede (oprindelige) interrupt

        Org     100H                    ; hop over program-segment-prefix
;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
MAIN:
        jmp     Install                 ; instaler driver (vender ikke retur)



IntProc Proc    Far
;------------------------------------------------------------------------
; Dette er den NYE Keyboard-Driver, som kaldes ved INT 16
;------------------------------------------------------------------------ 
        PushF                           ; save flags

        Cmp     Ah,1                    ; test funktion Ls fra buffer
        Jle     ReadKey                 ;  funktion 0 og 1

        PopF                            ; restore flags fra INT 16
        Int     KbdInt
        Sti                             ; der m igen hardware interuptes
        Ret     02                      ; returner men uden restore af flag
                                        ; da disse anvendes til meddelelser

ReadKey:
        PopF                            ; restore flags
        Int     KbdInt
        PushF                           ; save flags
        Cmp     Ah,0                    ; test om der er
        Je      EndIf                   ;   scan kode
Case:                                   ; husk der testes med fortegn sledes
                                        ; at 128-255 regnes som negative
        Cmp     Al,146                  ; test
        Je      StorAE                  ;   stort 
        Cmp     Al,157                  ; test
        Je      StorOE                  ;   stort 
        Cmp     Al,143                  ; test
        Je      StorAA                  ;   stort 
        Cmp     Al,145                  ; test
        Je      LilleAE                 ;   lille 
        Cmp     Al,155                  ; test
        Je      LilleOE                 ;   lille 
        Cmp     Al,134                  ; test
        Je      LilleAA                 ;   lille 
        Cmp     Al,65                   ; test                husk
        Jl      EndCase                 ;   om det            128 til 255 er
        Cmp     Al,90                   ;     er store        mindre end 65
        Jle     Stor                    ;       bogstaver     p.g.a. fortegn
        Cmp     Al,97                   ; test
        Jl      EndCase                 ;   om det
        Cmp     Al,122                  ;     er sm
        Jle     Smaa                    ;       bogstaver
        Jmp     EndCase 
        
Stor:
        Add     Al,32                   ; omregn til sm
        Jmp     EndCase 

Smaa:
        Sub     Al,32                   ; omregn til store
        Jmp     EndCase 

StorAE:
        Mov     Al,145                  ; ret til lille 
        Jmp     EndCase 
StorOE:
        Mov     Al,155                  ; ret til lille 
        Jmp     EndCase 
StorAA:
        Mov     Al,134                  ; ret til lille 
        Jmp     EndCase 

LilleAE:
        Mov     Al,146                  ; ret til stort 
        Jmp     EndCase 
LilleOE:
        Mov     Al,157                  ; ret til stort 
        Jmp     EndCase 
LilleAA:
        Mov     Al,143                  ; ret til stort 
        Jmp     EndCase 
EndCase :
EndIf:
        PopF                            ; restore flags fra INT 62
        Ret     02                      ; returner men uden restore af flag
                                        ; da disse anvendes til meddelelser

        db      'SLUT P KEYBOARDDRIVER'
DRIVEND:

IntProc EndP


Install PROC    Near
;-----------------------------------------------------------------------------
;       Rutine for instalation af driver
;-----------------------------------------------------------------------------

        mov     Ax,Cs                   ; etabler datasegment og staksegment
        mov     Ds,Ax                   ; adresse       (ikke ndv. hvis COM)
        mov     Ss,Ax                   ; adresse       (ikke ndv. hvis COM)
        mov     Sp,Offset InsStak       ; st stakptr   (ikke ndv. hvis COM)

        mov     Ah,35H
        mov     Al,KbdInt
        push    Ds
        int     21H                     ; Es = 0  => interuptnr er ledig
        pop     Ds
        mov     Ax,Es
        cmp     Ah,0
        jne     Optaget
        cmp     Al,0
        jne     Optaget

;  instalation af nyt driverprogram
        mov     Ah,35H                  ; hent dos printer
        mov     Al,BiosInt              ; interupt adresse
        int     21H

        push    Ds
        mov     Ax,Es
        mov     Ds,Ax
        mov     Ax,Bx
        mov     Dx,Ax
        mov     Ah,25H                  ; instaler oprindelig interupt
        mov     Al,KbdInt               ; p ny interuptkode
        int     21H
        pop     Ds
        
        push    Ds
        mov     Ax,Cs
        mov     Ds,Ax
        mov     Dx,Offset IntProc
        mov     Ah,25H                  ; instaler ny driver
        mov     Al,BiosInt              ; p dos interupt
        int     21H
        pop     Ds

        mov     Ah,9H
        mov     Dx,Offset oktxt
        int     21H

        mov     Dx,Offset DRIVEND+16    ; beregn ndvendig    (oprunding)
        mov     Cl,4                    ;   programstrrelse
        shr     Dx,Cl                   ;     i paragraffer
        mov     Ah,31h                  ; terminer og
        int     21H                     ; blev resident

Optaget:
; send fejlmeddelelse da interuptkode er optaget        
        mov     Ah,9H
        mov     Dx,Offset fejltxt
        int     21H

        mov     Ah,4CH
        int     21H                     ; terminate

fejltxt db      '>>>>>> Keyboarddriver kan ikke '
        db      'instaleres p INT 62 <<<<<<',13,10,'$'
oktxt   db      'Keyboarddriver er nu instaleret',13,10,'$'

install ENDP

;-----------------------------------------------------------------------------
;       Stak
;-----------------------------------------------------------------------------
        dw      256 dup(0)              ; der er sat 256 ord
InsStak :                               ;    af til stak
;-----------------------------------------------------------------------------


cseg    ends

        end     MAIN
